package com.gct.centralbase.config.easyExcel;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.alibaba.fastjson.JSONObject;
import com.gct.centralbase.entity.CbPcDevWellAttr;
import com.gct.centralbase.entity.CbPcProWellMeterTeam;
import com.gct.centralbase.service.impl.CbPcDevWellAttrServiceImpl;
import com.gct.centralbase.service.impl.CbPcProWellMeterTeamServiceImpl;
import com.gct.common.core.result.Result;
import com.gct.common.util.DateTimeUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.context.SecurityContextHolder;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * class name: DataListtener
 *
 * @author gxt
 * @version 1.0
 * @since 2021/9/26 上午10:09 周日
 */
public class DataCalibrationListener extends AnalysisEventListener<CbPcDevWellAttr> {




    CbPcDevWellAttrServiceImpl cbPcDevWellAttrServiceImpl;

    private static final int BATCH_COUNT = 100;
    List<CbPcDevWellAttr> list = new ArrayList<>();

    public DataCalibrationListener(CbPcDevWellAttrServiceImpl cbPcDevWellAttrServiceImpl){
        this.cbPcDevWellAttrServiceImpl = cbPcDevWellAttrServiceImpl;
    }

    @Override
    public void invoke(CbPcDevWellAttr cbPcDevWellAttr, AnalysisContext analysisContext) {
        cbPcDevWellAttr.setUpdateTime(cbPcDevWellAttr.getUpdateTime()+" 00:00:00");
        String username= SecurityContextHolder.getContext().getAuthentication().getName();
        cbPcDevWellAttr.setMarkedBy(username);
        cbPcDevWellAttr.setOilProductsSorting("1");
        cbPcDevWellAttr.setCoefficient(1.0);
        cbPcDevWellAttr.setIsmatching("是");
        Map<String, Object> processparamValue = new HashMap<>();
        processparamValue.put("explain", "null");
        processparamValue.put("date","null");
        processparamValue.put("count", "null");
        processparamValue.put("trend", "null");
        cbPcDevWellAttr.setMarkedParmExplain(JSONObject.toJSONString(processparamValue));
        if (cbPcDevWellAttrServiceImpl.findCbPcDevWellAttrByDate(cbPcDevWellAttr.getWellId(),cbPcDevWellAttr.getUpdateTime())!=null) { //标定
            cbPcDevWellAttrServiceImpl.deletecbPcDevWellAttr(cbPcDevWellAttr.getWellId(),cbPcDevWellAttr.getUpdateTime());
        }
        list.add(cbPcDevWellAttr);
        // 达到BATCH_COUNT了，需要去存储一次数据库，防止数据几万条数据在内存，容易OOM
        if (list.size()>=BATCH_COUNT){
            cbPcDevWellAttrServiceImpl.saveBatch(list);
            list.clear();
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        if (list.size()>0) cbPcDevWellAttrServiceImpl.saveBatch(list);
    }
}
