package com.gct.centralbase.config.easyExcel;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.alibaba.fastjson.JSON;
import com.gct.centralbase.entity.SysAccessWellControl;
import com.gct.centralbase.mapper.SysAccessWellControlMapper;
import com.gct.centralbase.service.SysAccessWellControlService;
import com.gct.centralbase.service.impl.SysAccessWellControlServiceImpl;
import org.postgresql.util.PSQLException;
import org.springframework.beans.factory.annotation.Autowired;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

import static com.alibaba.nacos.client.utils.EnvUtil.LOGGER;

/**
 * class name: DataListtener
 *
 * @author gxt
 * @version 1.0
 * @since 2021/9/26 上午10:09 周日
 */
public class DataListener extends AnalysisEventListener<SysAccessWellControl> {


    SysAccessWellControlServiceImpl sysAccessWellControlService;

    private static final int BATCH_COUNT = 100;
    List<SysAccessWellControl> list = new ArrayList<SysAccessWellControl>();

    public DataListener(SysAccessWellControlServiceImpl sysAccessWellControlService){
        this.sysAccessWellControlService = sysAccessWellControlService;
    }

    @Override
    public void invoke(SysAccessWellControl sysAccessWellControl, AnalysisContext analysisContext) {
        if (sysAccessWellControl.getAccessStatus() == 1){sysAccessWellControl.setAccessStatusMsg("已接入");}
        else if (sysAccessWellControl.getAccessStatus() == 0){sysAccessWellControl.setAccessStatusMsg("未接入");}
        sysAccessWellControl.setAccessDate(LocalDateTime.now());
        list.add(sysAccessWellControl);
        // 达到BATCH_COUNT了，需要去存储一次数据库，防止数据几万条数据在内存，容易OOM
        if (list.size()>=BATCH_COUNT){
            sysAccessWellControlService.saveBatch(list);
            list.clear();
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        if (list.size()>0) sysAccessWellControlService.saveBatch(list);
    }
}
