package com.gct.centralbase.config.easyExcel;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.gct.centralbase.entity.CbPcProWellMeterTeam;
import com.gct.centralbase.entity.SysAccessWellControl;
import com.gct.centralbase.service.impl.CbPcProWellMeterTeamServiceImpl;
import com.gct.centralbase.service.impl.SysAccessWellControlServiceImpl;
import com.gct.common.util.DateTimeUtil;
import org.springframework.security.core.context.SecurityContextHolder;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

/**
 * class name: DataListtener
 *
 * @author gxt
 * @version 1.0
 * @since 2021/9/26 上午10:09 周日
 */
public class DataMeterListener extends AnalysisEventListener<CbPcProWellMeterTeam> {


    CbPcProWellMeterTeamServiceImpl  cbPcProWellMeterTeamService;

    private static final int BATCH_COUNT = 100;
    List<CbPcProWellMeterTeam> list = new ArrayList<>();

    public DataMeterListener(CbPcProWellMeterTeamServiceImpl cbPcProWellMeterTeamService){
        this.cbPcProWellMeterTeamService = cbPcProWellMeterTeamService;
    }

    @Override
    public void invoke(CbPcProWellMeterTeam cbPcProWellMeterTeam, AnalysisContext analysisContext) {
        cbPcProWellMeterTeam.setStartProdDate(DateTimeUtil.formatDateTime(cbPcProWellMeterTeam.getDate()+" 00:00:00"));
        String username= SecurityContextHolder.getContext().getAuthentication().getName();
        cbPcProWellMeterTeam.setUpdateUserId(username);
        cbPcProWellMeterTeam.setCreateUserId(username);
        cbPcProWellMeterTeam.setCreateDate(LocalDateTime.now());
        cbPcProWellMeterTeam.setUpdateDate(LocalDateTime.now());

        if (cbPcProWellMeterTeamService.findCbcbPcProWellMeterTeam(cbPcProWellMeterTeam.getWellId(),cbPcProWellMeterTeam.getStartProdDate()).size()>0) { //标定
            cbPcProWellMeterTeamService.deletecbPcProWellMeterTeam(cbPcProWellMeterTeam.getWellId(),cbPcProWellMeterTeam.getStartProdDate());
        }

        list.add(cbPcProWellMeterTeam);
        // 达到BATCH_COUNT了，需要去存储一次数据库，防止数据几万条数据在内存，容易OOM
        if (list.size()>=BATCH_COUNT){
            cbPcProWellMeterTeamService.saveBatch(list);
            list.clear();
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        if (list.size()>0) cbPcProWellMeterTeamService.saveBatch(list);
    }
}
