package com.gct.centralbase.controller;

import com.gct.centralbase.service.CbCdWellSourceService;
import com.gct.common.core.result.Result;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.sql.ResultSet;

/**
 * @author xusirui 2021/5/6
 */
@RestController
@RequestMapping("/cbCdWellSource")
public class CbCdWellSourceController {

    @Autowired
    CbCdWellSourceService cbCdWellSourceService;

    @RequestMapping("/getWellInfo/{curPage}/{pageSize}")
    public Result getWellInfo(@PathVariable("curPage") Integer curPage,@PathVariable("pageSize") Integer pageSize){
        return cbCdWellSourceService.getWellInfo(curPage,pageSize);
    }

    @GetMapping("/getjhAll")
    public Result getjhAll() {
        return cbCdWellSourceService.getjhAll();
    }

    /**
     * 查询所有井用于分析误差率
     * @return
     */
    @GetMapping("/getjhAllYieldError")
    public Result getjhAllYieldError() {
        return cbCdWellSourceService.getjhAllYieldError();
    }

    /**
     * 查询所有井
     * @return
     */
    @GetMapping("/getjhAllConent")
    public Result getjhAllConent() {
        return cbCdWellSourceService.getjhAllConent();
    }

    @GetMapping("/getjhAllByorgid")
    public Result getjhAllByorgid(@RequestParam("orgid") @ApiParam("组织架构id") String orgid) {
        return cbCdWellSourceService.getjhAllByorgid(orgid);
    }

    /**
     * 根据井号查询稠油信息
     * @param wellName
     * @return
     */
    @GetMapping("/getByWellId_Heavy")
    public Result getByWellId_Heavy(@RequestParam("wellName") @ApiParam("井号") String wellName) {
        return cbCdWellSourceService.getByWellId_Heavy(wellName);
    }
}
