package com.gct.centralbase.controller;


import com.alibaba.excel.EasyExcelFactory;
import com.gct.centralbase.config.easyExcel.DataCalibrationListener;
import com.gct.centralbase.config.easyExcel.DataMeterListener;
import com.gct.centralbase.entity.CbPcProWellMeterTeam;
import com.gct.centralbase.service.CbPcDevWellAttrService;
import com.gct.centralbase.entity.CbPcDevWellAttr;
import com.gct.centralbase.service.impl.CbPcDevWellAttrServiceImpl;
import com.gct.centralbase.service.impl.CbPcProWellMeterTeamServiceImpl;
import com.gct.common.core.result.CodeMsgEnum;
import com.gct.common.core.result.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.yaml.snakeyaml.util.UriEncoder;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.List;

/**
 * <p>
 * 开发井基础数据 前端控制器
 * </p>
 *
 * @author 王森玉
 * @since 2021.8.16
 */
@RestController
@Api(value = "CbPcDevWellAttrController", description = "单井属性接口--添加/修改/删除/分页查询")
@RequestMapping("/cbPcDevWellAttr")
public class CbPcDevWellAttrController {

    @Autowired
    CbPcDevWellAttrService cbPcDevWellAttrService;


    @Autowired
    CbPcDevWellAttrServiceImpl cbPcDevWellAttrServiceImpl;


    @Value("${calibrationExcel}")
    private String calibrationExcel;

    @ApiOperation(value = "selectOneByWellId(根据井号获取单井属性数据)", notes = "单井属性数据")
    @GetMapping("/selectOneByWellId")
    public Result selectOneByWellId(
            @RequestParam("well_id") @ApiParam("输入井号") String well_id) {
        return cbPcDevWellAttrService.selectOneByWellId(well_id);
    }


    @ApiOperation(value = "selectOneByWellIdSeparator(根据井号和分离器查询单井属性数据)", notes = "单井属性数据")
    @GetMapping("/selectOneByWellIdSeparator")
    public Result selectOneByWellIdSeparator(
            @RequestParam("wellId") @ApiParam("输入井号") String wellId,
            @RequestParam("jobSystem") @ApiParam("输入工作制度") String jobSystem) {
        return cbPcDevWellAttrService.selectOneByWellIdSeparator(wellId,jobSystem);
    }

    @ApiOperation(value = "selectOneByOrgId(根据组织架构id查询分离器数据)", notes = "单井属性数据")
    @GetMapping("/selectOneByOrgId")
    public Result selectOneByOrgId(
            @RequestParam(value = "OrgIds",required = false) @ApiParam("输入组织架构Id") List<String> OrgIds,
            @RequestParam(value = "wellId",required = false) @ApiParam("输入井号") String wellId ,
            @RequestParam(value = "dateTime",required = false) @ApiParam("输入时间") String dateTime) {
        return cbPcDevWellAttrService.selectOneByOrgid(OrgIds,wellId,dateTime);
    }


    @ApiOperation(value = "addCbPcDevWellAttr(添加单井属性数据)", notes = "添加单井属性数据")
    @PostMapping("/addCbPcDevWellAttr")
    public Result addCbPcDevWellAttr(@RequestBody CbPcDevWellAttr cbPcDevWellAttr){
        return cbPcDevWellAttrService.addCbPcDevWellAttr(cbPcDevWellAttr);
    }

    @ApiOperation(value = "updateCbPcDevWellAttr(修改单井属性数据)", notes = "修改单井属性数据")
    @PostMapping("/updateCbPcDevWellAttr")
    public Result updateCbPcDevWellAttr(@RequestBody CbPcDevWellAttr cbPcDevWellAttr){
        return cbPcDevWellAttrService.updateCbPcDevWellAttr(cbPcDevWellAttr);
    }

    @ApiOperation(value = "updateCbPcDevWellAttrThinoil(修改单井属性数据)", notes = "修改单井属性数据")
    @PostMapping("/updateCbPcDevWellAttrThinoil")
    public Result updateCbPcDevWellAttrThinoil(@RequestBody CbPcDevWellAttr cbPcDevWellAttr){
        return cbPcDevWellAttrService.updateCbPcDevWellAttrThinoil(cbPcDevWellAttr);
    }

    @ApiOperation(value = "deleteCbPcDevWellAttr(删除单井属性数据)", notes = "删除单井属性数据")
    @GetMapping("/deleteCbPcDevWellAttr")
    public Result deleteCbPcDevWellAttr(@RequestParam("wellIds") @ApiParam("输入井号") String wellIds,
                                        @RequestParam("updateTime") @ApiParam("输入时间") String updateTime){
        return cbPcDevWellAttrService.deletecbPcDevWellAttr(wellIds,updateTime);
    }

    @ApiOperation(value = "deleteCbPcDevWellAttrLess(删除单井属性数据)", notes = "删除单井属性数据")
    @GetMapping("/deleteCbPcDevWellAttrLess")
    public Result deleteCbPcDevWellAttrLess(@RequestParam("wellIds") @ApiParam("输入井号") String wellIds,
                                        @RequestParam("updateTime") @ApiParam("输入时间") String updateTime){
        return cbPcDevWellAttrService.deleteCbPcDevWellAttrLess(wellIds,updateTime);
    }

    @ApiOperation(value = "updatehss(根据井号，膨胀系数进行修改)", notes = "根据井号，膨胀系数进行修改")
    @GetMapping("/updatePzxs")
    public Result updatePzxs(@RequestParam("well_id") @ApiParam("输入井号") String well_id,@RequestParam("pzxh") @ApiParam("输入膨胀系数") double pzxh){
        return cbPcDevWellAttrService.updatePzxs(well_id,pzxh);
    }


    @ApiOperation(value = "updateCoefficientByJh(根据井号，更新时间修改膨胀系数)", notes = "根据井号，更新时间修改膨胀系数")
    @GetMapping("/updateCoefficientByJh")
    public Result updateCoefficientByJh(@RequestParam("wellId") @ApiParam("输入井号") String wellId,
                                        @RequestParam("upateTime") @ApiParam("输入时间") String upateTime,
                                        @RequestParam("xs") @ApiParam("输入系数") double xs){
        return cbPcDevWellAttrService.updateCoefficientByJh(wellId,upateTime,xs);
    }

    @ApiOperation(value = "updatehssis(根据井号，膨胀系数匹配进行修改)", notes = "根据井号，膨胀系数进行修改")
    @GetMapping("/updateis")
    public Result updateis(@RequestParam("well_id") @ApiParam("输入井号") String well_id,@RequestParam("sfpp") @ApiParam("输入是否匹配") String sfpp,
                           @RequestParam("dateTime") @ApiParam("输入更新时间") String dateTime,
                           @RequestParam("fl") @ApiParam("输入分类") String fl){
        return cbPcDevWellAttrService.updateis(well_id,sfpp,dateTime,fl);
    }

    @ApiOperation(value = "updateisempty(对单井属性配置表进行是否匹配清空)", notes = "对单井属性配置表进行是否匹配清空")
    @GetMapping("/updateisempty")
    public Result updateisempty(@RequestParam("well_id") @ApiParam("输入井号") String well_id){
        return cbPcDevWellAttrService.updateisempty(well_id);
    }

    @ApiOperation(value = "findAllCbPcDevWellAttr(根据参数查询单井属性数据--分页查询)", notes = "根据参数查询单井属性数据")
    @GetMapping("/findAllCbPcDevWellAttr")
    public Result findAllCbPcDevWellAttr(
            @ApiParam(name = "pageNum",value = "当前页",required = true) @RequestParam("pageNum") Integer pageNum,
            @ApiParam(name = "pageSize",value = "页大小",required = true) @RequestParam("pageSize") Integer pageSize,
            @ApiParam(name = "org_id",value = "组织Id") @RequestParam(value = "org_id",required = false) String org_id,
            @ApiParam(name = "well_id",value = "井号") @RequestParam(value = "well_id",required = false) String well_id,
            @ApiParam(name = "oil_products_sorting",value = "油井分类") @RequestParam(value = "oil_products_sorting",required = false) String oil_products_sorting,
            @ApiParam(name = "test_type",value = "量油方式") @RequestParam(value = "test_type",required = false) String test_type,
            @ApiParam(name = "start_prod_stitum",value = "投产措施") @RequestParam(value = "start_prod_stitum",required = false) String start_prod_stitum,
            @ApiParam(name = "oil_production_method",value = "采油方式") @RequestParam(value = "oil_production_method",required = false) String oil_production_method,
            @ApiParam(name = "injection_method",value = "注入方式") @RequestParam(value = "injection_method",required = false) String injection_method,
            @ApiParam(name = "is_deviated",value = "是否斜井") @RequestParam(value = "is_deviated",required = false) String is_deviated,
            @ApiParam(name = "beginDate",value = "开始时间") @RequestParam(value = "beginDate",required = false) String beginDate,
            @ApiParam(name = "endDate",value = "截止时间") @RequestParam(value = "endDate",required = false) String endDate
    ){
        org_id = UriEncoder.decode(org_id);
        return cbPcDevWellAttrService.findAllCbPcDevWellAttr(pageNum,pageSize,org_id,well_id,oil_products_sorting,test_type,start_prod_stitum,oil_production_method,injection_method,is_deviated,beginDate,endDate);
    }

    @ApiOperation(value = "find_CbPcDevWellAttr_tj(获取单井属性柱状图)", notes = "获取单井属性柱状图")
    @GetMapping("/find_CbPcDevWellAttr_tj")
        public Result find_CbPcDevWellAttr_tj(
    ){
        return cbPcDevWellAttrService.find_CbPcDevWellAttr_tj();
    }

    @ApiOperation(value = "find_CbPcDevWellAttr_tjxx(根据单井属性类型获取对应的详细信息（柱状图）)", notes = "根据单井属性类型获取对应的详细信息（柱状图）")
    @GetMapping("/find_CbPcDevWellAttr_tjxx")
    public Result find_CbPcDevWellAttr_tjxx(@RequestParam("ismatching") @ApiParam("属性类型") String ismatching
    ){
        return cbPcDevWellAttrService.find_CbPcDevWellAttr_tjxx(ismatching);
    }

    @ApiOperation(value = "getCbPcDevWellAttrMaxUpdateTime(针对A2液量频繁变化查询最新膨胀系数更新时间)")
    @GetMapping("/getCbPcDevWellAttrMaxUpdateTime")
    public Result getCbPcDevWellAttrMaxUpdateTime(@RequestParam("wellId") @ApiParam("井号") String wellId,
                                                  @RequestParam("realDate") @ApiParam("实时时间") String realDate,
                                                  @RequestParam("flag") @ApiParam("标记") String  flag
    ){
        return Result.ok(cbPcDevWellAttrService.getCbPcDevWellAttrMaxUpdateTime(wellId,realDate,flag));
    }


    @ApiOperation(value = "selectOneByWellId(根据井号查询单井属性数据(集合))", notes = "根据井号查询单井属性数据(集合)")
    @GetMapping("/selectOneByWellIdList")
    public Result selectOneByWellIdList(
            @RequestParam("wellId") @ApiParam("输入井号") String wellId) {
        List<CbPcDevWellAttr> cbPcDevWellAttrList = cbPcDevWellAttrService.selectOneByWellIdList(wellId);
        return Result.ok(cbPcDevWellAttrList);
    }

    @ApiOperation(value = "selectOneByWellIdTimeList(根据井号，时间查询单井属性数据(集合))", notes = "根据井号查询单井属性数据(集合)")
    @GetMapping("/selectOneByWellIdTimeList")
    public Result selectOneByWellIdTimeList(
            @RequestParam("wellId") @ApiParam("输入井号") String wellId,@RequestParam("updateTime") @ApiParam("输入时间") String updateTime) {
        List<CbPcDevWellAttr> cbPcDevWellAttrList = cbPcDevWellAttrService.selectOneByWellIdTimeList(wellId,updateTime);
        return Result.ok(cbPcDevWellAttrList);
    }


    @ApiOperation(value = "downLoadCalibrationExample(下载标定示例)", notes = "downLoadCalibrationExample")
    @GetMapping("/downLoadCalibrationExample")
    public void downLoadCalibrationExample(HttpServletResponse response) throws IOException {
        // 设置contenttype，即告诉客户端所发送的数据属于什么类型
        response.setContentType("application/vnd.ms-excel");
        response.setCharacterEncoding("utf-8");
        OutputStream outputStream = response.getOutputStream();
        byte[] buff = new byte[1024];
        BufferedInputStream bis = null;
        InputStream inputStream = this.getClass().getClassLoader().getResourceAsStream("exampleExcel/exampleCalibration.xlsx");
        assert inputStream != null;
        bis = new BufferedInputStream(inputStream);
        int i = bis.read(buff);
        while (i != -1) {
            outputStream.write(buff, 0, buff.length);
            outputStream.flush();
            i = bis.read(buff);
        }
        bis.close();
        outputStream.close();
    }

    @ApiOperation(value = "uploadCalibration(批量上传)", notes = "uploadCalibration(批量上传)")
    @RequestMapping(value = "/uploadCalibration",method = RequestMethod.POST,headers = "Content-Type= multipart/form-data")
    public Result upload(@RequestParam("file") MultipartFile excelFile) throws IOException {
        File file = new File(calibrationExcel);
        if (!file.getParentFile().exists()) file.getParentFile().mkdirs();
        if (!file.exists()){
            file.createNewFile();
        }
        excelFile.transferTo(file);
        EasyExcelFactory.read(file, CbPcDevWellAttr.class,new DataCalibrationListener(cbPcDevWellAttrServiceImpl)).sheet().doRead();
        if (file.delete()){
            return Result.ok("success");
        }else {
            return Result.ok("failed");
        }
    }




}

