package com.gct.centralbase.controller;


import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.EasyExcelFactory;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gct.centralbase.config.easyExcel.DataListener;
import com.gct.centralbase.config.easyExcel.DataMeterListener;
import com.gct.centralbase.entity.CbPcProWellMeterTeam;
import com.gct.centralbase.entity.SysAccessWellControl;
import com.gct.centralbase.entity.Vo.AccessWellExcelVo;
import com.gct.centralbase.service.CbPcProWellMeterTeamService;
import com.gct.centralbase.service.impl.CbPcProWellMeterTeamServiceImpl;
import com.gct.common.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

/**
 * <p>
 * 人工计产数据 前端控制器
 * </p>
 *
 * @author wsy
 * @since 2021-09-10
 */
@RestController
@RequestMapping("/CbPcProWellMeterTeam")
public class CbPcProWellMeterTeamController {
    @Autowired
    CbPcProWellMeterTeamService cbPcProWellMeterTeamService;

    @Autowired
    CbPcProWellMeterTeamServiceImpl cbPcProWellMeterTeamServiceImpl;

    @Value("${tempMeterExcel}")
    private String tempMeterExcel;
    /**
     * 针对量液服务获取计产数据
     *
     * @param WellName
     * @param dateTime
     * @return
     */
    @RequestMapping(value = "/getWellMeterTeamForCalProduction", method = RequestMethod.GET)
    public Result getWellMeterTeamForCalProduction(@RequestParam(value = "WellName") String WellName, @RequestParam(value = "dateTime") String dateTime) {

        return cbPcProWellMeterTeamService.getWellMeterTeamForCalProduction(WellName, dateTime);
    }

    @PostMapping("/list")
    public Result getList(@RequestBody JSONObject jsonObject) {
        return Result.ok(cbPcProWellMeterTeamService.getList(jsonObject));
    }
    @PostMapping("/save")
    public Result saveData(@RequestBody CbPcProWellMeterTeam cbPcProWellMeterTeam){
        return Result.ok(cbPcProWellMeterTeamService.saveData(cbPcProWellMeterTeam));
    }
    @GetMapping("/downLoadMeterExample")
    public void downLoadExcelExample(HttpServletResponse response) throws IOException {
        // 设置contenttype，即告诉客户端所发送的数据属于什么类型
        response.setContentType("application/vnd.ms-excel");
        response.setCharacterEncoding("utf-8");
        OutputStream outputStream = response.getOutputStream();
        byte[] buff = new byte[1024];
        BufferedInputStream bis = null;
        InputStream inputStream = this.getClass().getClassLoader().getResourceAsStream("exampleExcel/exampleMeter.xlsx");
        assert inputStream != null;
        bis = new BufferedInputStream(inputStream);
        int i = bis.read(buff);
        while (i != -1) {
            outputStream.write(buff, 0, buff.length);
            outputStream.flush();
            i = bis.read(buff);
        }
        bis.close();
        outputStream.close();
    }


    @RequestMapping(value = "/uploadMeter",method = RequestMethod.POST,headers = "Content-Type= multipart/form-data")
    public Result upload(@RequestParam("file") MultipartFile excelFile) throws IOException {
        File file = new File(tempMeterExcel);
        if (!file.getParentFile().exists()) file.getParentFile().mkdirs();
        if (!file.exists()){
            file.createNewFile();
        }
        excelFile.transferTo(file);
        EasyExcelFactory.read(file,CbPcProWellMeterTeam.class,new DataMeterListener(cbPcProWellMeterTeamServiceImpl)).sheet().doRead();
        if (file.delete()){
            return Result.ok("success");
        }else {
            return Result.ok("failed");
        }
    }


    /**
     * 根据参数条件删除人工计量数据
     *
     * @param WellName
     * @param dateTime
     * @return
     */
    @RequestMapping(value = "/deletecbPcProWellMeterTeam", method = RequestMethod.GET)
    public Result deletecbPcProWellMeterTeam(@RequestParam(value = "WellName") String WellName, @RequestParam(value = "dateTime") String dateTime) {

        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        return cbPcProWellMeterTeamService.deletecbPcProWellMeterTeam(WellName,  LocalDateTime.parse(dateTime,df));
    }

}

