package com.gct.centralbase.controller;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.EasyExcelFactory;
import com.gct.centralbase.config.easyExcel.DataListener;
import com.gct.centralbase.entity.SysAccessWellControl;
import com.gct.centralbase.entity.Vo.AccessWellExcelVo;
import com.gct.centralbase.entity.Vo.AccessWellInfoVo;
import com.gct.centralbase.mapper.SysAccessWellControlMapper;
import com.gct.centralbase.service.SysAccessWellControlService;
import com.gct.centralbase.service.impl.SysAccessWellControlServiceImpl;
import com.gct.common.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.multipart.MultipartFile;

import javax.activation.MimetypesFileTypeMap;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.nio.charset.StandardCharsets;
import java.util.List;
import java.util.Objects;

/**
 * class name: SysAccessWellController
 *
 * @author gxt
 * @version 1.0
 * @since 2021/9/22 上午11:14 周三
 */
@RestController
@RequestMapping("/accessWell")
public class SysAccessWellControlController {

    @Value("${tempExcel}")
    private String tempExcel;
    

    @Autowired
    SysAccessWellControlService sysAccessWellService;
    @Autowired
    SysAccessWellControlServiceImpl sysAccessWellControlService;

    @PostMapping("/getAccessWellInfo")
    public Result getAccessWellInfo(@RequestBody AccessWellInfoVo accessWellInfoVo){
        return Result.ok(sysAccessWellService.getAccessWellInfo(accessWellInfoVo));
    }

    @PostMapping("/addAccessWellInfo")
    public Result addAccessWellInfo(@RequestBody AccessWellInfoVo accessWellInfoVo){
        return Result.ok(sysAccessWellService.addAccessWellInfo(accessWellInfoVo));
    }

    @PostMapping("/updateAccessStatus")
    public Result updateAccessStatus(@RequestBody AccessWellInfoVo accessWellInfoVo){
        return Result.ok(sysAccessWellService.updateAccessStatus(accessWellInfoVo));
    }

    @PostMapping("/updateAllAccessStatus")
    public Result updateAllAccessStatus(){
        return Result.ok(sysAccessWellService.updateAccessStatus());
    }


    @RequestMapping(value = "/upload",method = RequestMethod.POST,headers = "Content-Type= multipart/form-data")
    public Result upload(@RequestParam("file") MultipartFile excelFile) throws IOException {
        File file = new File(tempExcel);
        if (!file.getParentFile().exists()) file.getParentFile().mkdirs();
        if (!file.exists()){
            file.createNewFile();
        }
        excelFile.transferTo(file);
        EasyExcelFactory.read(file,SysAccessWellControl.class,new DataListener(sysAccessWellControlService)).sheet().doRead();
        if (file.delete()){
            return Result.ok("success");
        }else {
            return Result.ok("failed");
        }
    }

    @GetMapping("/downLoadExcelExample")
    public void downLoadExcelExample(HttpServletResponse response) throws IOException {
        // 设置contenttype，即告诉客户端所发送的数据属于什么类型
        response.setContentType("application/vnd.ms-excel");
        response.setCharacterEncoding("utf-8");
        OutputStream outputStream = response.getOutputStream();
        byte[] buff = new byte[1024];
        BufferedInputStream bis = null;
        InputStream inputStream = this.getClass().getClassLoader().getResourceAsStream("exampleExcel/example.xlsx");
        assert inputStream != null;
        bis = new BufferedInputStream(inputStream);
        int i = bis.read(buff);
        while (i != -1) {
            outputStream.write(buff, 0, buff.length);
            outputStream.flush();
            i = bis.read(buff);
        }
        bis.close();
        outputStream.close();
    }
    @GetMapping("/getWellControlList")
    public Result getWellControlList(){
        return  Result.ok(sysAccessWellService.getWellControlList());
    }

    @PostMapping("/exportExcelAccess")
    public void exportExcelAccess(@RequestBody SysAccessWellControl sysAccessWellControl, HttpServletResponse response) throws IOException {
        List<AccessWellExcelVo> collect =  sysAccessWellService.exportExcelAccess(sysAccessWellControl);
        response.setContentType("application/vnd.ms-excel");
        response.setCharacterEncoding("utf-8");
        EasyExcel.write(response.getOutputStream(), AccessWellExcelVo.class).sheet("接入井控制").doWrite(collect);
    }
}
