package com.gct.centralbase.entity;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.format.DateTimeFormat;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.gct.centralbase.config.easyExcel.LocalDateTimeConverter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 *
 * </p>
 *
 * @author 王森玉
 * @since 2021-09-10
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value = "人工计产数据表", description = "")
@TableName("centralbase.cb_pc_pro_well_meter_team")
@NoArgsConstructor
@AllArgsConstructor
public class CbPcProWellMeterTeam extends Model<CbPcProWellMeterTeam> {

    private static final long serialVersionUID = 1L;

    @ExcelProperty(value = "井号",index = 0)
    private String wellId;
    @TableField(exist = false)
    private String zyq;
    @TableField(exist = false)
    private String jq;

    @TableField(exist = false)
    private String zd;


    private String wellboreId;


    private String completionId;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime startProdDate;


    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime endProdDate;

    @ExcelProperty(value = "计量时间",index = 1)
    @TableField(exist = false)
    @DateTimeFormat("yyyy-MM-dd")
    private String date;

    @ExcelProperty(value = "量油时间",index = 2)
    private Double testingOilTime;

    @ExcelProperty(value = "计量产液量",index = 3)
    private Double testLiquVolDaily;

    private Double selLiquVolDaily;

    private Double testGasVolDaily;

    private Double selGasVolDaily;

    private String isUsing;

    private Double testWatVolDaily;

    private Double testCondensateOil;

    private Double liquMixTag;

    private Double testOilVolDaily;

    private Double liquAssignPercent;

    private Double gasAssignPercent;
    private Double testingGasTime;
    private Double measureHeight;

    private Double endMeasureHeight;
    private Double startMeasureHeight;
    private Double testingGasStart;
    private Double testingGasEnd;
    private Double atmospherePres;
    private Double gasMoment;
    private Double gasProd_cum;

    private Double liquVolDailyMoment;

    private Double liquVolDailyCum;

    private Double gasInjMoment;

    private String pCheckId;

    private String upLoadFlag;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime createDate;

    private String createUserId;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime updateDate;

    private String updateUserId;

    private String remark;

    @Override
    protected Serializable pkVal() {
        return this.wellId;
    }

}
