package com.gct.centralbase.entity;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.format.DateTimeFormat;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.gct.centralbase.config.easyExcel.LocalDateTimeConverter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 * class name: SysAccessWell
 *
 * @author gxt
 * @version 1.0
 * @since 2021/9/22 上午11:18 周三
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="SysAccessWell对象", description="接入井")
@TableName("centralbase.sys_access_well_control")
@NoArgsConstructor
@AllArgsConstructor
public class SysAccessWellControl {

    @ExcelProperty(value = "井号", index = 0)
    @ApiModelProperty(value = "井号")
    private String wellId;

    @ExcelProperty(value = "井名", index = 1)
    @ApiModelProperty(value = "井名")
    private String wellCommonName;

    @ExcelIgnore
    @ApiModelProperty(value = "机构id")
    private String orgId;

    @ExcelIgnore
    @ApiModelProperty(value = "备注")
    private String remarks;

    @ExcelProperty(value = "井接入状态 0未接入,1 已接入", index = 2)
    @ApiModelProperty(value = "井接入状态；0 未接入, 1 已接入")
    private Integer accessStatus;

    @ExcelIgnore
    @ApiModelProperty(value = "接入状态描述")
    private String accessStatusMsg;

    @ExcelIgnore
    @ApiModelProperty(value = "井接入日期")
   // @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    @DateTimeFormat("yyyy-MM-dd HH:mm:ss")
    private LocalDateTime accessDate;
}
