package com.gct.centralbase.job;

import com.gct.centralbase.service.CbTempWellMechRuntimeService;
import com.gct.common.util.DateTimeUtil;
import lombok.extern.slf4j.Slf4j;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.quartz.QuartzJobBean;

import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * class name: CalErrorDataJob
 *
 * @author gxt
 * @version 1.0
 * @since 2021/12/23 上午11:25 周四
 */
@Slf4j
public class CalErrorDataJob extends QuartzJobBean {

    @Autowired
    CbTempWellMechRuntimeService cbTempWellMechRuntimeService;

    @Override
    protected void executeInternal(JobExecutionContext context) {
        try {
            log.info("enter calErrorData");
            cbTempWellMechRuntimeService.calErrorData(LocalDateTime.now());
            log.info("out calErrorData");
        }catch (Exception e){
            log.error("calErrorData:"+e.getMessage());
            e.printStackTrace();
        }

    }
}
