package com.gct.centralbase.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.gct.centralbase.entity.CbCdWellSource;
import com.gct.centralbase.entity.CbPcDevWellAttr;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gct.common.core.result.Result;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 开发井基础数据 Mapper 接口
 * </p>
 *
 * @author wsy
 * @since 2021-08-16
 */
public interface CbPcDevWellAttrMapper extends BaseMapper<CbPcDevWellAttr> {

    /**
     * 根据Id查询单井属性表
     * @param well_id
     * @return
     */
    CbPcDevWellAttr selectOneByWellId(@Param("well_id") String well_id);


    List<CbPcDevWellAttr> selectOneByOrgid(@Param("OrgIds") List<String> OrgIds,
                                          @Param("dateTime") String dateTime);

    List<CbPcDevWellAttr> selectOneByWell(@Param("wellId") String wellId,
                                           @Param("dateTime") String dateTime);


    /**
     * 根据井号和分离器查询单井属性数据
     * @param wellId
     * @return
     */
    CbPcDevWellAttr selectOneByWellIdSeparator(@Param("wellId") String wellId,
                                               @Param("jobSystem") String jobSystem);

    /**
     * 根据Id查询单井属性表/时间
     * @param well_id
     * @param update
     * @return
     */
    CbPcDevWellAttr selectOneByWellIdByupdate(@Param("well_id") String well_id,@Param("update") String update);


    int updatePzxs(@Param("wellid") String wellid,@Param("pzxh") double pzxh);





    int updateCbPcDevWellAttr(@Param("WellId") String WellId,@Param("OilProductsSorting") String OilProductsSorting,
                              @Param("MarkedParmExplain") String MarkedParmExplain,
                              @Param("Ismatching") String Ismatching,@Param("Coefficient") double Coefficient,
                              @Param("UpdateTime") String UpdateTime,@Param("MarkedBy") String MarkedBy);

    int updateCoefficientByJh(@Param("wellid") String wellid,@Param("upateTime") String upateTime,@Param("xs") double xs);



    int updateis(@Param("wellid") String wellid,@Param("sfpp") String sfpp,@Param("dateTime") String dateTime,@Param("fl") String fl);

    int updateisempty(@Param("wellid") String wellid);
    int deletecbPcDevWellAttr(@Param("wellid") String wellid,@Param("updateTime") String updateTime);

    int deleteCbPcDevWellAttrLess(@Param("wellid") String wellid,@Param("updateTime") String updateTime);



    int deleteCbPcDevWellAttrLessQj(@Param("wellid") String wellid,@Param("updateTimeStart") String updateTimeStart,
                                    @Param("updateTimeEnd") String updateTimeEnd);



    /**
     * 根据参数条件查询单井属性数据
     * @param page
     * @param oil_products_sorting
     * @param test_type
     * @param start_prod_stitum
     * @param oil_production_method
     * @param injection_method
     * @param is_deviated
     * @param beginDate
     * @param endDate
     * @return
     */
    IPage<CbPcDevWellAttr> selectCbPcDevWellAttrList(IPage<?> page,
                                                     @Param("well_id") List<String> well_id,
                                                     @Param("oil_products_sorting") String oil_products_sorting,
                                                     @Param("test_type") String test_type,
                                                     @Param("start_prod_stitum") String start_prod_stitum,
                                                     @Param("oil_production_method") String oil_production_method,
                                                     @Param("injection_method") String injection_method,
                                                     @Param("is_deviated") String is_deviated,
                                                     @Param("beginDate") String beginDate,
                                                     @Param("endDate") String endDate);



}
