package com.gct.centralbase.mapper;

import com.alibaba.fastjson.JSONArray;
import com.gct.centralbase.entity.CbPcDevWellAttr;
import com.gct.centralbase.entity.CbPcOrganization;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gct.common.core.result.Result;
import org.apache.ibatis.annotations.CacheNamespace;
import org.apache.ibatis.annotations.Param;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.security.core.parameters.P;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 组织机构 Mapper 接口
 * </p>
 *
 * @author wsy
 * @since 2021-01-19
 */

public interface CbPcOrganizationMapper extends BaseMapper<CbPcOrganization> {

    List<CbPcOrganization> getOrgId(@Param("orgId") String orgId);

    List<Map<String,Object>> getSubOrgIDsWithMaxLevel(@Param("cycleLevel") int cycleLevel,@Param("orgID") String orgID);


    List<CbPcOrganization> getSubOrgIDsWithMaxLevel(@Param("sqlStatement") String sql);

    CbPcOrganization getOrgByWellId(@Param("wellId") String wellId);


    List<String> getWellIdsByOrgIds(@Param("orgIds") List<String> orgIds);

    Object getOrgInfoByWellID(@Param("wellId") String wellId);

    List<String> getWellIdAndOrgIdLevelOne(@Param("orgIds") List<String> orgIds);


    /**
     * 通过组织架构名称查询组织架构id
     * @param orgName
     * @return
     */
    CbPcOrganization getOrgByOrgName(@Param("orgName") String orgName);

}
