package com.gct.centralbase.service;

import com.alibaba.fastjson.JSONArray;
import com.gct.centralbase.entity.CbCdWellSource;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.common.core.result.Result;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * <p>
 * 单井基础信息 服务类
 * </p>
 *
 * @author wsy
 * @since 2021-01-19
 */
public interface CbCdWellSourceService extends IService<CbCdWellSource> {

    /**
     * 获取井号数据
     * @return
     */
    Result getWellSource(String orgid);


    /**
     * 根据组织架构Id获取单井数据
     * @param orgid
     * @return
     */
    Result getjh(String orgid);


    Result searchWellsByOrgID(String seachText,String orgID);

    Result searchWellsByOrgID2(String seachText, String orgID);

    Result searchWellsByOrgIDAuthorize(String searchText, String orgID, JSONArray orgRoleStr);

    CbCdWellSource getByWellId(String wellName);


    Result getWellSourceByStationName(String stationName,String producingAreaName);

    Result getWellInfo(Integer curPage,Integer pageSize);


    /**
     * 查询所有井
     * @return
     */
    Result  getjhAll();

    /**
     * 查询所有井用于分析误差率
     * @return
     */
    Result  getjhAllYieldError();

    /**
     * 查询所有井
     * @return
     */
    Result  getjhAllConent();

    /**
     * 根据组织架构id查询井
     * @param orgid
     * @return
     */
    Result  getjhAllByorgid(String orgid);

    /**
     * 根据井号查询稠油
     * @param wellName
     * @return
     */
    Result getByWellId_Heavy(String wellName);

    Result getWellSourceByWellIdList(List<String> wellId);

    List<CbCdWellSource> getWellInfoByList(List<String> wellId);

    //Result getAllWells(int curPage, int pageSize);
}
