package com.gct.centralbase.service;

import com.gct.centralbase.entity.CbPcDevWellAttr;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.common.core.result.Result;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 开发单井属性数据 服务类
 * </p>
 *
 * @author wsy
 * @since 2021-08-16
 */
public interface CbPcDevWellAttrService extends IService<CbPcDevWellAttr> {

    /**
     * 根据Id查询单井属性数据
     * @param well_id
     * @return
     */
    Result selectOneByWellId(String well_id);


    /**
     * 根据井号和分离器查询单井属性数据
     * @param wellId
     * @return
     */
    Result selectOneByWellIdSeparator(String wellId,String jobSystem);

    /**
     * 添加单井属性信息
     * @param cbPcDevWellAttr
     * @return
     */
    Result addCbPcDevWellAttr(CbPcDevWellAttr cbPcDevWellAttr);


    /**
     * 对单井属性配置表进行是否匹配清空
     * @param
     * @param
     * @return
     */
     Result deletecbPcDevWellAttr(String wellid,String UpdateTime);


    /**
     * 对单井属性配置表进行是否匹配清空
     * @param
     * @param
     * @return
     */
    Result deleteCbPcDevWellAttrLess(String wellid,String UpdateTime);



    /**
     * 修改单井属性信息
     * @param cbPcDevWellAttr
     * @return
     */
    Result updateCbPcDevWellAttr(CbPcDevWellAttr cbPcDevWellAttr);

    /**
     * 修改单井属性信息(稀油)
     * @param cbPcDevWellAttr
     * @return
     */
    Result updateCbPcDevWellAttrThinoil(CbPcDevWellAttr cbPcDevWellAttr);


    /**
     * 根据井号进行膨胀系数的修改
     * @param wellid
     * @param pzxh
     * @return
     */
    Result updatePzxs(String wellid,double pzxh);

    /**
     * 根据井号，更新时间修改膨胀系数
     * @param wellid
     * @param upateTime
     * @return
     */
    Result updateCoefficientByJh(String wellid,String upateTime,double xs);


    /**
     * 编辑是否匹配
     * @param wellid
     * @param sfpp
     * @return
     */
    Result updateis(String wellid,String sfpp,String dateTime,String fl);



    /**
     * 对单井属性配置表进行是否匹配清空(参数：井号)
     * @return
     */
    Result updateisempty(String wellid);

    /**
     * 根据参数条件查询单井属性数据
     * @param pageNum
     * @param pageSize
     * @param org_id
     * @param well_id
     * @param oil_products_sorting
     * @param test_type
     * @param start_prod_stitum
     * @param oil_production_method
     * @param injection_method
     * @param is_deviated
     * @param beginDate
     * @param endDate
     * @return
     */
    Result findAllCbPcDevWellAttr(Integer pageNum, Integer pageSize, String org_id, String well_id, String oil_products_sorting, String test_type, String start_prod_stitum, String oil_production_method, String injection_method, String is_deviated, String beginDate, String endDate);



    /**
     * 获取单井属性类型柱状图
     * @return
     */
    Result find_CbPcDevWellAttr_tj();

    /**
     * 根据单井属性类型获取对应的详细信息（柱状图）
     * @return
     */
    Result find_CbPcDevWellAttr_tjxx(String ismatching);


    /**
     * 根据组织架构id查询分离器数据
     * @param OrgIds
     * @return
     */
    Result selectOneByOrgid(List<String> OrgIds,String wellId,String dateTime);

    /**
     * 针对A2液量频繁变化查询最新膨胀系数更新时间
     * @param wellId
     * @return
     */
    CbPcDevWellAttr getCbPcDevWellAttrMaxUpdateTime(String wellId,String realDate,String flag);



    /**
     * 根据井号查询单井属性数据(集合)
     * @param wellId
     * @return
     */
    List<CbPcDevWellAttr> selectOneByWellIdList(String wellId);


    /**
     * 根据井号查询单井属性数据(集合)
     * @param wellId
     * @return
     */
    List<CbPcDevWellAttr> selectOneByWellIdTimeList(String wellId,String updateTime);


}

