package com.gct.centralbase.service;

import com.alibaba.fastjson.JSONArray;
import com.gct.centralbase.entity.CbPcOrganization;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.common.core.result.Result;

import java.util.List;

/**
 * <p>
 * 组织机构 服务类
 * </p>
 *
 * @author wsy
 * @since 2021-01-19
 */
public interface CbPcOrganizationService extends IService<CbPcOrganization> {

    /**
     * 获取组织架构数据
     *
     * @return
     */
    Result getOrganization(String orgStr);


    List<CbPcOrganization> getParentOrgAsc(String wellId);

    String getParAndSonOrg(JSONArray orgArr);


    /**
     * 通过组织架构名称查询组织架构id
     * @param orgName
     * @return
     */
     Result getOrgByOrgName(String orgName);
    /**
     * 树形结构查询
     *
     * @return
     */
    Result findTree();


    /**
     * 通过id查询该部门下的所有子部门id 列表
     *
     * @param orgid
     * @return
     */
    List<String> findAllIdById(String orgid);

    /**
     * 通过组织架构id和等级获取所属id
     * @param id
     * @param orgLevel
     * @return
     */
    List<String> findAllIdByIdLevel(String id,int orgLevel);



    /**
     * 从组织机构中获取orgId
     *
     * @param orgId
     */
    List<CbPcOrganization> getOrgId(String orgId);

    CbPcOrganization getOrgById(String id);

    Integer getMaxLevelFromOrg();

    List<String> findSubOrgIDWithMaxLevel(String id, int level);

    String getOrgByWellId(String wellId);

    List<String> getWellIdByOrgId(String orgId);

    Object getMaxLevelOrgId();

    List<String> getWellIdsByOrgIds(List<String> orgIds);

    Object getOrgInfoByWellID(String wellId);

    Object getOrgIdByOrgLevel();

    List<String> getWellIdAndOrgIdLevelOne(List<String> orgIds);

    Result findTreeAuthorize(JSONArray orgSet);


    /**
     * 根据组织架构id输出名称
     * @param orgid
     * @return
     */
    String getOrgByName(String orgid);
}
