package com.gct.centralbase.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.centralbase.entity.CbPcProWellboreStatusDaily;
import com.gct.centralbase.mapper.CbPcProWellboreStatusDailyMapper;
import com.gct.centralbase.service.CbPcProWellboreStatusDailyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gct.common.core.result.Result;
import com.gct.common.util.DateTimeUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

/**
 * <p>
 * 采出井井筒状态日数据 服务实现类
 * </p>
 *
 * @author wsy
 * @since 2021-01-19
 */
@Service
public class CbPcProWellboreStatusDailyServiceImpl extends ServiceImpl<CbPcProWellboreStatusDailyMapper, CbPcProWellboreStatusDaily> implements CbPcProWellboreStatusDailyService {

    @Autowired
    CbPcProWellboreStatusDailyMapper mapper;

    @Override
    public Result getWellBoreStatusDaily(String wellId, String prodDate) {
        return Result.ok(mapper.getWellBoreStatusDaily(wellId,prodDate));
    }

    @Override
    public CbPcProWellboreStatusDaily getA2DataForCalProduction(String wellName, String dateTime) {
        return mapper.getA2DataForCalProduction(wellName,dateTime);
    }

    /**
     * 针对没有油压/套压
     * @param wellId
     * @param prodDate
     * @return
     */
    public Result getWellBoreStatus(String wellId,String prodDate) {

        LocalDateTime start = DateTimeUtil.formatDateTime(prodDate +" 00:00:00");
        LocalDateTime end = DateTimeUtil.formatDateTime(prodDate +" 23:59:59");
        QueryWrapper<CbPcProWellboreStatusDaily> queryWrapper = new QueryWrapper<>();
        queryWrapper.select("tubing_pres,casing_pres");
        queryWrapper.eq("well_id",wellId);
        queryWrapper.gt("pro_time",start);
        queryWrapper.lt("pro_time",end);
        return Result.ok( baseMapper.selectList(queryWrapper));

    }

}
